#ifndef _CONFIG_H_
#define _CONFIG_H_

#define DEBUG

/* Maximum number of CPUs */
#define CFG_SMP 1

#ifdef CFG_SMP
#   define MAX_CPUS         8
#	define LOCK_PREFIX		"lock;"
#else
#   define MAX_CPUS         1
#	define LOCK_PREFIX		""
#endif

#define SMP_CACHE_BYTES 128

#define ____cacheline_aligned __attribute__((__aligned__(SMP_CACHE_BYTES)))

#define __KERNEL__ 1

/* No need to use atomic instruction to write APIC registers */
#define CONFIG_X86_GOOD_APIC 1

#endif /* _CONFIG_H_ */
