#include <includes.h>
#include <system.h>
#include <console.h>
#include <thread.h>
#include "md/i686/md.h"
#include "md/i686/msr.h"

void test_console();


void kernel_main()
{
	u32 reg_esp;
	u32 bsp;
	u32 i;
	u64 tsc;
	
	init_system();
	
	if ( is_bsp() )
	{
		init_BSP();
		bsp = 1;
	}
	else
	{
		init_APs();
		bsp = 0;
	}

	//	init_console(); 
	//	test_console();	
	for (i=0;;i++)
	{
		
		if ( bsp )
		{
			mdelay( 1000 );
		}
		else
		{
			mdelay( 1 );
		}
		
//		mdelay( 1 );
		
		asm("mov %%esp, %0" : "=m"(reg_esp) : "0"(reg_esp)  );
		rdtscll( tsc );
		
		printk("[%d] CPU %d - [tsc:%llu][esp:%x] is_bsp=%d \n", i, thr_cpu_id(), tsc, reg_esp, bsp );
	}
}

void test_console()
{
	u32 i;
	u8 ch;
	
	con_clear();
	
	for ( i=0; i< 30; i++ ) {
//		printk("[%d] abc..\n", i);
/*		
		for (ch='A'; ch <='Z'; ch ++ )
		{
			con_putc( ch );			
		}
*/		
	}
}

