; NASM macro set to make interfacing to 32-bit programs easier -*- nasm -*-



%imacro proc 1			; begin a procedure definition

%push proc

          global %1

%1:       push ebp

          mov ebp,esp

%assign %$arg 8

%define %$procname %1

%endmacro



%imacro arg 0-1 4		; used with the argument name as a label

%00	  equ %$arg

%assign %$arg %1+%$arg

%endmacro



%imacro endproc 0

%ifnctx proc

%error Mismatched `endproc'/`proc'

%else

	  leave

	  ret

__end_%$procname:		; useful for calculating function size

%pop

%endif

%endmacro


%imacro putchar16 1
    push ax
    push ds
		mov ax, 0B000h
		mov ds, ax
		mov word [08000h], 9F00h + %1
	pop ds
	pop ax
%endmacro

%imacro putchar 1
	mov word [0B8000h],9F00h + %1
%endmacro

; %1 : memory location
; %2 : register
%imacro try_spin_lock_ 2
	mov %2, 1
	lock
	xchg %1, %2
%endmacro


CR equ 0ah