#ifndef _CONSOLE_DRV_H_
#define _CONSOLE_DRV_H_

void init_console();

/****************** Interfaces Exported Outside i686 ************************/

void con_scroll_up();

/*
 * Cursor x and y is 0-indexed values
 */
OS_INLINE u32 con_get_cursor_x();
OS_INLINE u32 con_get_cursor_y();
void con_set_cursor_pos( const u32 x, const u32 y );

void con_putc( const u8 ch );
void con_puts( const u8 * str );
void con_clear();

#endif
