#ifndef _SYSTEM_H_
#define _SYSTEM_H_ 1

/****************** Interfaces Exported Outside i686 ************************/

/* in md.c */
void halt();

void init_system();

OS_INLINE u32 is_bsp();

/*
 * only booting processors (BSP) excecutes this routine
 */
void init_BSP();

/*
 * only application processors (AP) excecutes this routine
 */
void init_APs();

/*
 * CAUTION !!
 * When you port to another machine, init_stack_if_ap that is defined as inline 
 * should also be defined as inline in a new platform 
 * because stack is not available for application processors.
 */
#define init_stack_if_ap()\
{\
}

#endif /* _SYSTEM_H_ */
