#include <includes.h>

#include <vsnprintf.h>
#include <console_drv.h>
#include <console.h>


/*
	BUGBUG 
	do some kernel concurrency here 
	for multiple threads' accessing console
 */
#define CON_PRINTF_BUFFER_SIZE (1024)


void printk( const u8 *fmt, ... )
{
	static char buf[ CON_PRINTF_BUFFER_SIZE + 1 ];

	int ret;

	va_list args;

	va_start(args, fmt);

	ret = vsnprintf( buf, CON_PRINTF_BUFFER_SIZE, fmt, args );
	
	buf[ ret ] = '\0';
	
	con_puts(buf);
	
	va_end(args);
}


void panic( const u8 * msg )
{
	printk( "kernel panic : %s.", msg );
	halt();
}

