#ifndef _SPINLOCK_DESC_H_
#define _SPINLOCK_DESC_H_ 1

#define spin_lock_irqsave(lock, flags)		\
{											\
	local_irq_save(flags); 					\
	preempt_disable(); 						\
}
 
#define spin_unlock_irqrestore(lock, flags) \
{											\
	local_irq_restore(flags);				\
	preempt_enable();						\
} 

/*
#define spin_lock_irqsave(lock, flags)		\
{											\
	local_irq_save(flags); 					\
	preempt_disable(); 						\
//	_raw_spin_lock(lock); 					\
}
 
#define spin_unlock_irqrestore(lock, flags) \
{											\
//	_raw_spin_unlock(lock);					\
	local_irq_restore(flags);				\
	preempt_enable();						\
} 
*/
#endif /* SPINLOCK_DESC_H_ */
