#ifndef _VA_ARG_H_
#define _VA_ARG_H_ 1


#define _ADDRESSOF(v)	( &(v) )
#define _INTSIZEOF(n)	( (sizeof(n) + sizeof(int) - 1) & ~(sizeof(int) - 1) )


/****************** Interfaces Exported Outside i686 ************************/

typedef char			*va_list;

#define va_start(ap,v)	( ap = (va_list)_ADDRESSOF(v) + _INTSIZEOF(v) )
#define va_arg(ap,t)	( *(t *)((ap += _INTSIZEOF(t)) - _INTSIZEOF(t)) )
#define va_end(ap)		( ap = (va_list)0 )

#endif /* _VA_ARG_H_ */ 
